#include <qthing.h>

#include "esp_pm.h"
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"

// Power state guard
static bool max_power = false;

namespace qthing {
  void power_managment_max_power() {
    if (!max_power) {
      max_power = true;

      esp_pm_config_esp32_t esp_pm_config;
      esp_pm_config.max_cpu_freq = RTC_CPU_FREQ_240M;
      //esp_pm_config.max_freq_mhz = 240;
      esp_pm_config.min_cpu_freq = RTC_CPU_FREQ_240M;
      //esp_pm_config.min_freq_mhz = 240;
      esp_pm_config.light_sleep_enable = false;
      ESP_ERROR_CHECK(esp_pm_configure(&esp_pm_config));

      vTaskDelay(200 / portTICK_PERIOD_MS);
    }
  }
}